// SPDX-License-Identifier: (GPL-2.0+ OR MIT)
/*
 * Copyright (C) 2020 Telechips Inc.
 */
#ifndef DT_BINDINGS_PMAP_TCC805X_ANDROID_IVI_DISPLAY_H
#define DT_BINDINGS_PMAP_TCC805X_ANDROID_IVI_DISPLAY_H

/*********************************** DISPLAY **********************************/
#define PRIMARY_FRAMEBUFFER_WIDTH       (1920)
#define PRIMARY_FRAMEBUFFER_HEIGHT      (720)
#define SECONDARY_FRAMEBUFFER_WIDTH     (1920)
#define SECONDARY_FRAMEBUFFER_HEIGHT    (720)
#define TERTIARY_FRAMEBUFFER_WIDTH      (0)
#define TERTIARY_FRAMEBUFFER_HEIGHT     (0)

// Choose bigger resolution between Primary and Secondary display device.
// and Should sync with hardware/telechips/common/hwcomposer/Hwrenderer.h
#define PRIMARY_TARGET_WIDTH            (1920)
#define PRIMARY_TARGET_HEIGHT           (720)
#define SECONDARY_TARGET_WIDTH          (0)
#define SECONDARY_TARGET_HEIGHT         (0)
#define TERTIARY_TARGET_WIDTH           (0)
#define TERTIARY_TARGET_HEIGHT          (0)

#if ((PRIMARY_TARGET_WIDTH*PRIMARY_TARGET_HEIGHT) > \
	(SECONDARY_TARGET_WIDTH*SECONDARY_TARGET_HEIGHT))
#define SUPPORT_DISPLAY_MAX_WIDTH       (PRIMARY_TARGET_WIDTH)
#define SUPPORT_DISPLAY_MAX_HEIGHT      (PRIMARY_TARGET_HEIGHT)
#else
#define SUPPORT_DISPLAY_MAX_WIDTH       (SECONDARY_TARGET_WIDTH)
#define SUPPORT_DISPLAY_MAX_HEIGHT      (SECONDARY_TARGET_HEIGHT)
#endif

//****************************** Camera ******************************/
#define CAMERA_INPUT_WIDTH		1280
#define CAMERA_INPUT_HEIGHT		720
#define CAMERA_OUTPUT_WIDTH		1920
#define CAMERA_OUTPUT_HEIGHT		1080

#define FRAMES_CAMERA_VIQE		0
#define FRAMES_CAMERA_PREVIEW0		0
#define FRAMES_CAMERA_PREVIEW1		0
#define FRAMES_CAMERA_PREVIEW2		0
#define FRAMES_CAMERA_PREVIEW3		0
#define FRAMES_CAMERA_PREVIEW4		0
#define FRAMES_CAMERA_PREVIEW5		0
#define FRAMES_CAMERA_PREVIEW6		0
#define FRAMES_CAMERA_PREVIEW7		0
#define FRAMES_CAMERA_PGL		0
#define FRAMES_CAMERA_LASTFRAME		0

//****************************** Calculation ******************************/
#undef SZ_1MB
#define SZ_1MB				(1024*1024)
#undef ARRAY_16MBYTE
#define ARRAY_16MBYTE(x)		((((x) + ((16*SZ_1MB)-1)) >> 24) << 24)
#undef ARRAY_MBYTE
#define ARRAY_MBYTE(x)			((((x) + (SZ_1MB-1)) >> 20) << 20)
#undef ARRAY_256KBYTE
#define ARRAY_256KBYTE(x)		((((x) + ((SZ_1MB/4)-1)) >> 18) << 18)

#if 0
#define PMAP_SIZE_FB_VIDEO		\
	ARRAY_MBYTE(PRIMARY_FRAMEBUFFER_WIDTH * \
		PRIMARY_FRAMEBUFFER_HEIGHT * 4 * 3)
#define PMAP_SIZE_FB1_VIDEO		\
	ARRAY_MBYTE(SECONDARY_FRAMEBUFFER_WIDTH * \
		SECONDARY_FRAMEBUFFER_HEIGHT * 4 * 3)
#define PMAP_SIZE_FB2_VIDEO		\
	ARRAY_MBYTE(TERTIARY_FRAMEBUFFER_WIDTH * \
		TERTIARY_FRAMEBUFFER_HEIGHT * 4 * 3)
#define PMAP_SIZE_OVERLAY_ROT		\
	ARRAY_MBYTE(PRIMARY_FRAMEBUFFER_WIDTH * \
		PRIMARY_FRAMEBUFFER_HEIGHT * 4 * FRAMES_OVERLAY_ROT)
#define PMAP_SIZE_UMP_RESERVED		\
	ARRAY_MBYTE((PRIMARY_FRAMEBUFFER_WIDTH * 4) * \
		PRIMARY_FRAMEBUFFER_HEIGHT * 4 * 4)
#endif
#define PMAP_SIZE_CAMERA_VIQE		\
	ARRAY_MBYTE((CAMERA_INPUT_WIDTH * (CAMERA_INPUT_HEIGHT / 2) * 4 * \
		FRAMES_CAMERA_VIQE) * 3 / 2)
#define PMAP_SIZE_CAMERA_PREVIEW0	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW0)
#define PMAP_SIZE_CAMERA_PREVIEW1	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW1)
#define PMAP_SIZE_CAMERA_PREVIEW2	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW2)
#define PMAP_SIZE_CAMERA_PREVIEW3	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW3)
#define PMAP_SIZE_CAMERA_PREVIEW4	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW4)
#define PMAP_SIZE_CAMERA_PREVIEW5	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW5)
#define PMAP_SIZE_CAMERA_PREVIEW6	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW6)
#define PMAP_SIZE_CAMERA_PREVIEW7	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PREVIEW7)
#define PMAP_SIZE_CAMERA_PGL		\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_PGL)
#define PMAP_SIZE_CAMERA_LASTFRAME	\
	ARRAY_MBYTE(CAMERA_OUTPUT_WIDTH * CAMERA_OUTPUT_HEIGHT * 4 * \
		FRAMES_CAMERA_LASTFRAME)
#define PMAP_SIZE_EARLY_REARCAM		(\
	PMAP_SIZE_CAMERA_VIQE + \
	PMAP_SIZE_CAMERA_PREVIEW0 + \
	PMAP_SIZE_CAMERA_PREVIEW1 + \
	PMAP_SIZE_CAMERA_PREVIEW2 + \
	PMAP_SIZE_CAMERA_PREVIEW3 + \
	PMAP_SIZE_CAMERA_PREVIEW4 + \
	PMAP_SIZE_CAMERA_PREVIEW5 + \
	PMAP_SIZE_CAMERA_PREVIEW6 + \
	PMAP_SIZE_CAMERA_PREVIEW7 + \
	PMAP_SIZE_CAMERA_LASTFRAME + \
	PMAP_SIZE_CAMERA_PGL)

#endif//DT_BINDINGS_PMAP_TCC805X_ANDROID_IVI_DISPLAY_H
